unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CartoVP, CartoMisc, CGFtable, SObjTables, GrTables,
  TB97Ctls, TB97, TB97Tlbr, Buttons, Menus, Gauges, Spin, ComCtrls, MIFimport,
  rwmain2;

const
  Fcolor: array [0..15] of integer =
  ($FFFFFF,
   $0000FF,$00FF00,$00FFFF,
   $FFFF80,$0080FF,$4D4D99,
   $808040,$FF0000,$808080,
   $C0C0C0,$8000FF,$008080,
   $C080FF,$808000,$FF8080);

type
  TMainForm = class(TForm)
    CreateButton: TButton;
    Memo1: TMemo;
    LoadButton: TButton;
    gv: TGraphicViewport;
    cgflink: TCGFTable;
    cgfnode: TCGFTable;
    Toolbar972: TToolbar97;
    btnZoomIn: TToolbarButton97;
    btnPan: TToolbarButton97;
    btnZoomOut: TToolbarButton97;
    btnExtents: TToolbarButton97;
    MIFImport1: TMIFImport;
    MIFImport2: TMIFImport;
    ClearButton: TButton;
    MainMenu1: TMainMenu;
    Advancedfunctions1: TMenuItem;
    Subnets1: TMenuItem;
    Parallellinks1: TMenuItem;
    CulDeSac1: TMenuItem;
    CulDeSac2: TMenuItem;
    Joinlinks1: TMenuItem;
    Distancetable1: TMenuItem;
    Standardfunctions1: TMenuItem;
    Drivedistance1: TMenuItem;
    TSP: TMenuItem;
    Gauge1: TGauge;
    MIFImport3: TMIFImport;
    cgfiso: TCGFTable;
    Panel1: TPanel;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpinEdit3: TSpinEdit;
    CheckBox2: TCheckBox;
    IsoPoly1Button: TButton;
    SpinEdit4: TSpinEdit;
    Label4: TLabel;
    CloseNodes1: TMenuItem;
    MultiIsochrones11: TMenuItem;
    MultiIsochrones21: TMenuItem;
    Unusedlinks1: TMenuItem;
    Path1: TMenuItem;
    Shortestpath: TMenuItem;
    FastestPath: TMenuItem;
    About1: TMenuItem;
    Create3centers1: TMenuItem;
    Create8centers1: TMenuItem;
    IsoGrid11: TMenuItem;
    IsoGrid21: TMenuItem;
    Centers1: TMenuItem;
    Create15centers1: TMenuItem;
    N1: TMenuItem;
    cgfcenter: TCGFTable;
    Panel2: TPanel;
    Label5: TLabel;
    RandomButton: TButton;
    PathButton1: TButton;
    PathButton2: TButton;
    rwcalc1: TRWcalc;
    RWnet1: TRWnetBase;
    BtnNearest: TToolbarButton97;
    Node1button: TToolbarButton97;
    Node2Button: TToolbarButton97;
    Panel3: TPanel;
    CheckBox4: TCheckBox;
    IsoPoly3Button: TButton;
    Viewresults1: TMenuItem;
    map: TMenuItem;
    tab: TMenuItem;
    shp: TMenuItem;
    CheckBox5: TCheckBox;
    SpinEdit5: TSpinEdit;
    Label6: TLabel;
    CheckBox6: TCheckBox;
    Edit1: TEdit;
    editnode1: TEdit;
    editnode2: TEdit;
    Panel4: TPanel;
    IsoPoly2Button: TButton;
    Edit2: TEdit;
    Label7: TLabel;
    Panel5: TPanel;
    CheckBox3: TCheckBox;
    CheckBox1: TCheckBox;
    Label8: TLabel;
    SpinEdit6: TSpinEdit;
    procedure CreateButtonClick(Sender: TObject);
    procedure PathButton1Click(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure btnExtentsClick(Sender: TObject);
    procedure MIFImport1ImportError(Sender: TObject; ErrorMessage: String);
    procedure CheckBox1Click(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RandomButtonClick(Sender: TObject);
    procedure Subnets1Click(Sender: TObject);
    procedure Distancetable1Click(Sender: TObject);
    procedure Drivedistance1Click(Sender: TObject);
    procedure TSPClick(Sender: TObject);
    procedure MIFImport1ProgressChange(Sender: TObject; Progress: Byte;
      CountPolygons, CountPolylines, CountPoints, NoText,
      NoEllipses: Integer);
    procedure IsoPoly1ButtonClick(Sender: TObject);
    procedure CloseNodes1Click(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure rwcalc1NWLoadProgress(Sender: TObject; Progress: Byte);
    procedure rwcalc1NWCreateProgress(Sender: TObject; Progress: Byte;
      var StopProcess: Boolean);
    procedure MultiIsochrones11Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ShortestpathClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure IsoGrid11Click(Sender: TObject);
    procedure Create3centers1Click(Sender: TObject);
    procedure Create8centers1Click(Sender: TObject);
    procedure Create15centers1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure gvMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mapClick(Sender: TObject);
    procedure IsoPoly3ButtonClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure editnode1KeyPress(Sender: TObject; var Key: Char);
    procedure IsoPoly2ButtonClick(Sender: TObject);
  private
    { Private declarations }
    procedure center(n: integer);
    procedure adjust;
    procedure clear;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  nodenum: integer;
  pathtype: byte;
  notshowed: boolean;

implementation

uses math,about;

{$R *.DFM}

procedure TMainForm.center(n: integer);
var
  i,node: integer;
  Coord: TFloatPoint;
  so,st: TBasicObjectStyle;
  ThisPointInfo: TPointInfo;
  ThisTextInfo: TTextInfo;
  WorkLine: string;
begin
  cgfcenter.Active:= false;
  cgfcenter.createnewtable;
  so.PenWidth:= 2; so.PenColor:= clRed; so.penmode:= pmCopy;
  so.PenStyle:= psSolid; so.brushcolor:= clGray;
  with ThisPointInfo do
  begin
    Shape:= 15;
    Size:= 11;
  end;

  st.PenColor:= clBlack; st.PenMode:= pmCopy; st.PenWidth:= 1;
  st.PenStyle:= psSolid; st.BrushColor:= clWhite; st.BrushStyle:= bsClear;

  for i:= 1 to n do
  begin
    {random points, you should normally check that your points are on
     the main net and not in a subnet}
    node:= trunc(rwnet1.nodemax*random+1);
    rwcalc1.NodeListSet(i,node);

    coord.x:= rwnet1.nodecoordX(node);
    coord.y:= rwnet1.nodecoordY(node);
    cgfcenter.CreatePoint(so,Coord,ThisPointInfo);

    WorkLine:= '   '+inttostr(node);
    with ThisTextInfo do
    begin
      Width:= 0;
      Height:= 0;
      Angle:= 0;
      FontName:= 'Arial';
      FontSize:= 9;
      FontStyle:= [fsBold];
      StrPCopy(@Text,WorkLine);
      InsertionPoint:= coord;
    end;
    cgfcenter.CreateText(st,ThisTextInfo);
  end;
  cgfcenter.Active:= true;
  if gv.layers[0].layerstate.visible then gv.redrawimagedata;
  nodenum:= n;
end;

procedure TMainForm.adjust;
begin
  case pathtype of
    0: begin
         rwcalc1.CostDist:= 1;
         rwcalc1.CostTime:= 0;
         rwcalc1.ExtraDist:= 0;
         rwcalc1.ExtraTime:= 1;
       end;
    1: begin
         rwcalc1.CostDist:= 0;
         rwcalc1.CostTime:= 1;
         rwcalc1.ExtraDist:= 1;
         rwcalc1.ExtraTime:= 0;
       end;
  end;
  rwcalc1.Alpha:= rwcalc1.OptimumAlpha;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  left:= 8;
  top:= 8;
  toolbar972.top:= gv.top+52;
  toolbar972.left:= gv.left+16;
  decimalseparator:= '.';
  pathtype:= 0;
  randseed:= 10;
  rwcalc1.SetNet(rwnet1); //link net-object and calc-object
  notshowed:= true;
end;

procedure TMainForm.ShortestpathClick(Sender: TObject);
begin
  TMenuitem(Sender).checked:= true;
  if sender=Shortestpath then pathtype:= 0;
  if sender=Fastestpath then pathtype:= 1;
  adjust;
end;

procedure TMainForm.clear;
var
  so: TbasicObjectstyle;
begin
  so.PenWidth:= 1; so.PenColor:= clBlack; so.brushcolor:= clBlack;
  so.penmode:= pmCopy; so.PenStyle:= psSolid;
  gv.layers[2].RemoveStyleOverride;
  gv.layers[2].InitStyleOverride(so);
  gv.layers[1].RemoveStyleOverride;
  gv.layers[1].InitStyleOverride(so);
end;

procedure TMainForm.CreateButtonClick(Sender: TObject);
var
  err: integer;
begin
  screen.cursor:= crHourglass;
  gauge1.Progress:= 0;
  gauge1.visible:= true;
  err:= rwnet1.NWCreateMIF('link',true);
  if err<>0 then showmessage('Could not create network: '+inttostr(err)) else
  begin
    err:= rwnet1.attributecreate('link.mid');
    if err<>0 then showmessage('Could not create attributes: '+inttostr(err)) else
    begin
      cgflink.active:= false;
      cgfnode.active:= false;
      gauge1.Progress:= 0;
      Mifimport1.Execute;
      gauge1.Progress:= 0;
      Mifimport2.Execute;
    end;
  end;
  gauge1.visible:= false;
  screen.cursor:= crDefault;
end;

procedure TMainForm.LoadButtonClick(Sender: TObject);
var
  err: integer;
begin
  screen.cursor:= crHourglass;
  try
    cgflink.active:= true;
    cgfnode.active:= true;
    gv.layers[2].layerstate.visible:= true; {link}
    clear;
    gv.ZoomToVisibleExtents;
    gv.RedrawImageData;
    gauge1.progress:= 0;
    gauge1.visible:= true;
    err:= rwnet1.NWLoad;
    gauge1.visible:= false;
    if err=0 then
    begin
      rwnet1.setspeed(1,110);
      rwnet1.setspeed(2,90);
      rwnet1.setspeed(3,80);
      rwnet1.setspeed(4,70);
      rwnet1.setspeed(5,60);
      rwnet1.setspeed(6,50);
      rwnet1.setspeed(17,110);
      rwnet1.setspeed(18,70);
      rwnet1.setspeed(19,50);
      rwnet1.setspeed(20,40);
      rwnet1.setspeed(21,35);
      rwnet1.setspeed(22,30);
      err:= rwnet1.attributeread(true);
      adjust;
      if err=0 then
      begin
        memo1.Lines.add('Number of links: '+inttostr(rwnet1.linkmax));
        memo1.Lines.add('Number of nodes: '+inttostr(rwnet1.nodemax));
        PathButton1.Enabled:= true;
        PathButton2.Enabled:= true;
        Advancedfunctions1.Enabled:= true;
        ClearButton.Enabled:= true;
        Standardfunctions1.Enabled:= true;
        Isopoly1button.Enabled:= true;
        Isopoly2button.Enabled:= true;
        Isopoly3button.Enabled:= true;
        RandomButton.enabled:= true;
        if rwcalc1.ExtraVarCreate<0 then showmessage('Extra variable has not been created');
        Centers1.enabled:= true;
        center(3);
        gv.layers[0].layerstate.visible:= true;
        gv.RedrawImageData;
      end else showmessage('Could not load attributes');
    end else showmessage('Could not load network');
  except
    on exception do showmessage('Try to create the network first');
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.PathButton1Click(Sender: TObject);
var
  node1,node2,i,length: longint;
  res: double;
  so: TbasicObjectstyle;
  err: integer;
  Coord: TFloatPoint;
  ThisPointInfo: TPointInfo;
begin
  node1:= strtoint(trim(editnode1.text));
  node2:= strtoint(trim(editnode2.text));
  if (rwnet1.checknode(node1)) and (rwnet1.checknode(node2)) then
  begin
    if sender=PathButton2 then
    begin
      i:= node2; node2:= node1; node1:= i;
    end;
    res:= rwcalc1.route(node1,node2);
    if ((res>0) and (res<1e+36)) or (res=-33) then
    begin
      if res=-33 then length:= rwcalc1.routefind(rwcalc1.bestnode)
        else length:= rwcalc1.routefind(node2);
      if map.checked then
      begin
        so.PenWidth:= 2; so.PenColor:= clRed; so.brushcolor:= clRed;
        so.penmode:= pmCopy; so.PenStyle:= psSolid;
        for i:= 1 to length-1 do
          gv.Layers[2].OverrideStyle(abs(rwcalc1.routegetlink(i)),so);
        for i:= 2 to length-1 do
          gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(i),so);
        so.brushcolor:= clYellow;
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(1),so);
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(length),so);

        if res=-33 then
        begin
          so.PenWidth:= 2; so.PenColor:= clRed; so.penmode:= pmCopy;
          so.PenStyle:= psSolid; so.brushcolor:= clRed;
          ThisPointInfo.Shape:= 2;
          ThisPointInfo.Size:= 11;
          coord.x:= rwnet1.nodecoordX(node2);
          coord.y:= rwnet1.nodecoordY(node2);
          cgfcenter.CreatePoint(so,Coord,ThisPointInfo);
        end;
        gv.RedrawImageData;
      end else
      begin
        err:= rwcalc1.routesave(true,true);
        if err<>0 then showmessage('Could not save result '+inttostr(err));
      end;
      if res=-33 then
        showmessage('Node '+inttostr(node2)+' was not found. Calculated route to nearest node instead')
      else
      case pathtype of
        0: memo1.lines.add(floattostrF(res,ffFixed,6,2)+' Km  '+floattostrF(rwcalc1.GetNodeExtra(node2),ffFixed,6,2)+' Min.');
        1: memo1.lines.add(floattostrF(rwcalc1.GetNodeExtra(node2),ffFixed,6,2)+' Km  '+floattostrF(res,ffFixed,6,2)+' Min.');
      end;
    end else showmessage('Could not find a route');
  end else showmessage('Wrong node-number(s)');
end;

procedure TMainForm.btnExtentsClick(Sender: TObject);
begin
  if Sender=btnExtents  then GV.ZoomToVisibleExtents else
  if Sender=btnZoomIn   then begin btnZoomIn.Down:= True; GV.Mode:= vpmZoomIn; end else
  if Sender=btnZoomOut  then begin btnZoomOut.Down:= True; GV.Mode:= vpmZoomOut; end else
  if Sender=btnPan      then begin btnPan.Down:= True; GV.Mode:= vpmPan; end else
  if Sender=BtnNearest  then begin BtnNearest.Down:= True; GV.Mode:= vpmUserDefined; end else
  if Sender=Node1Button then
  begin
    Node1Button.Down:= True;
    GV.Mode:= vpmUserDefined;
  end else
  if Sender=Node2Button then
  begin
    Node2Button.Down:= True;
    GV.Mode:= vpmUserDefined;
  end;
end;

procedure TMainForm.MIFImport1ImportError(Sender: TObject;
  ErrorMessage: String);
begin
  showmessage('Could not import link.MIF');
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  gv.layers[1].layerstate.visible:= checkbox1.checked;
  gv.RedrawImageData;
end;

procedure TMainForm.ClearButtonClick(Sender: TObject);
begin
  if map.checked then
  begin
    clear;
    gv.layers[3].layerstate.visible:= false;
    gv.RedrawImageData;
  end else rwcalc1.resultfileclear(true,true);
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  gv.height:= mainform.height-60;
  gv.width:= mainform.width-gv.left-15;
end;

procedure TMainForm.RandomButtonClick(Sender: TObject);
begin
  editnode1.text:= inttostr(round(random(rwnet1.nodemax)+1));
  editnode2.text:= inttostr(round(random(rwnet1.nodemax)+1));
end;

procedure TMainForm.Subnets1Click(Sender: TObject);
var
  i,t: longint;
  so: array [0..2] of TBasicObjectStyle;
  err: integer;
begin
  screen.cursor:= crHourglass;
  err:= 0;
  if Sender=Subnets1 then err:= rwcalc1.SubNet else
  if Sender=Parallellinks1 then err:= rwcalc1.ParallelLinks else
  if Sender=CulDeSac1 then err:= rwcalc1.CulDeSac(1) else
  if Sender=CulDeSac2 then err:= rwcalc1.CulDeSac(2) else
  if Sender=Unusedlinks1 then err:= rwcalc1.UnusedLinks else
  if Sender=Joinlinks1 then err:= rwcalc1.join(0,'');
  screen.cursor:= crDefault;
  if err<0 then showmessage('Error in function '+inttostr(err)) else
  begin
    if sender=CulDeSac2 then showmessage('All one-way streets are now two-way streets. Use load network to get back to normal');
    if map.checked then
    begin
      so[0].PenWidth:= 1; so[0].PenColor:= clBlack;
      so[0].penmode:= pmCopy; so[0].PenStyle:= psSolid;
      gv.layers[2].RemoveStyleOverride;
      gv.layers[2].InitStyleOverride(so[0]);
      so[1]:= so[0]; so[1].PenWidth:= 2; so[1].PenColor:= clLime;
      so[2]:= so[0]; so[2].PenWidth:= 2; so[2].PenColor:= clBlue;
      if Sender=Subnets1 then
      begin
        for i:= 1 to rwnet1.linkmax do
        begin
          t:= round(rwcalc1.resultgetlink(i));
          if t>0 then
          begin
            so[2].penColor:= Fcolor[t mod 15];
            gv.Layers[2].OverrideStyle(i, so[2]);
          end;
        end;
      end else
      begin
        for i:= 1 to rwnet1.linkmax do
        begin
          if (Sender=CulDeSac2) or (Sender=Unusedlinks1) then
            gv.Layers[2].OverrideStyle(i, so[round(rwcalc1.resultgetlink(i))]) else
          if rwcalc1.resultgetlink(i)<>0 then gv.Layers[2].OverrideStyle(i, so[1]);
        end;
      end;
      gv.RedrawImageData;
    end else
    begin
      err:= rwcalc1.resultsavelink;
      if err<>0 then showmessage('Could not save link-result '+inttostr(err));
    end;
  end;
end;

procedure TMainForm.Distancetable1Click(Sender: TObject);
var
  output: textfile;
  i,j: longint;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  try try
    assignfile(output,'table1.txt');
    rewrite(output);
    write(output,'         ');
    for j:= 1 to nodenum do write(output,rwcalc1.nodelistget(j):8,' ');
    writeln(output);
    for i:= 1 to nodenum do
    begin
      rwcalc1.isocost(rwcalc1.nodelistget(i),0);
      write(output,rwcalc1.nodelistget(i):8,' ');
      for j:= 1 to nodenum do write(output,rwcalc1.getnodecost(rwcalc1.nodelistget(j)):8:2,' ');
      writeln(output);
    end;
    closefile(output);
    showmessage('Now look in "table1.txt" for the result');
  except
    on exception do showmessage('An error occured');
  end;
  finally
    screen.cursor:= crDefault;
  end;
end;

procedure TMainForm.Drivedistance1Click(Sender: TObject);
var
  i,node1: longint;
  t: double;
  so: TBasicObjectStyle;
  err: integer;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  node1:= strtoint(trim(editnode1.text));
  err:= rwcalc1.isocost(node1,2);    // 2 km
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    if map.checked then
    begin
      so.PenWidth:= 1; so.PenColor:= clBlack; so.brushcolor:= clBlack;
      so.penmode:= pmCopy; so.PenStyle:= psSolid;
      so.PenWidth:= 2;
      for i:= 1 to rwnet1.linkmax do
      begin
        t:= min(rwcalc1.getlinkcost(i),rwcalc1.getlinkcost(-i));
        if t<1e+36 then
        begin
          so.pencolor:= $00FFFF+$FFFF*round(t/2*255);
          gv.Layers[2].OverrideStyle(i,so);
        end;
      end;
      for i:= 1 to rwnet1.nodemax do
      begin
        t:= rwcalc1.getnodecost(i);
        if t<1e+36 then
        begin
          so.brushcolor:= $00FFFF+$FFFF*round(t/2*255);
          if i=node1 then so.brushcolor:= clRed;
          gv.Layers[1].OverrideStyle(i,so);
        end;
      end;
      gv.RedrawImageData;
    end else
    begin
      err:= rwcalc1.isocostsave(true,true,false);
      if err<0 then showmessage('Could not save result '+inttostr(err));
    end;
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.TSPClick(Sender: TObject);
var
  length,i,j,node2,err: longint;
  so: TBasicObjectStyle;
  res: double;
begin
  screen.cursor:= crHourglass;
  {run}
  rwcalc1.tsp(nodenum,1);

  {draw results}
  for j:= 1 to nodenum do
  begin
    if j<>nodenum then node2:= rwcalc1.NodeListget(j+1) else node2:= rwcalc1.NodeListget(1);
    res:= rwcalc1.route(rwcalc1.NodeListget(j),node2);
    if (res>0) and (res<1e+36) then
    begin
      length:= rwcalc1.routefind(node2);
      if map.checked then
      begin
        so.PenWidth:= 2; so.PenColor:= clRed; so.brushcolor:= clRed;
        so.penmode:= pmCopy; so.PenStyle:= psSolid;
        for i:= 1 to length-1 do
          gv.Layers[2].OverrideStyle(abs(rwcalc1.routegetlink(i)),so);
        for i:= 2 to length-1 do
          gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(i),so);
        so.brushcolor:= clYellow;
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(1),so);
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(length),so);
      end else
      begin
        err:= rwcalc1.routesave(true,true);
        if err<>0 then showmessage('Could not save result '+inttostr(err));
      end;
    end else showmessage('Error when calculating route - node in subnet');
  end;
  gv.RedrawImageData;
  screen.cursor:= crDefault;
end;

procedure TMainForm.MIFImport1ProgressChange(Sender: TObject; Progress: Byte;
  CountPolygons, CountPolylines, CountPoints, NoText, NoEllipses: Integer);
begin
  gauge1.progress:= progress;
end;

procedure TMainForm.IsoPoly1ButtonClick(Sender: TObject);
var
  node,err: longint;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  node:= strtoint(trim(editnode1.text));
  err:= rwcalc1.isopoly1('isopoly1',node,spinedit1.value,spinedit2.value,
                       spinedit3.value,checkbox2.checked,spinedit4.value);
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    mifimport3.MIFLocation:= 'isopoly1.mif';
    Mifimport3.Execute;
    cgfiso.active:= true;
    gv.layers[3].RemoveStyleOverride;
    gv.layers[3].layerstate.visible:= true;
    gv.redrawimagedata;
  end;
  screen.cursor:= crDefault;
  if (spinedit3.value>1) and (not checkbox2.checked) then
    showmessage('You will have to import into mapinfo/arcview to see non-doughnut isochrones properly');
end;

procedure TMainForm.CloseNodes1Click(Sender: TObject);
var
  t,i,err: longint;
  so: TBasicObjectStyle;
  midfile: textfile;
  line: string;
begin
  screen.cursor:= crHourglass;
  err:= rwnet1.findclosenodes(0.010);
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  if not map.checked then showmessage('Import closenodes.mif to see the result in MapInfo/ArcView') else
  begin
    mifimport3.MIFLocation:= 'closenodes.mif';
    Mifimport3.Execute;
    cgfiso.active:= true;
    gv.layers[3].layerstate.visible:= true;

    so.PenWidth:= 1; so.brushcolor:= clRed;
    so.penmode:= pmCopy; so.PenStyle:= psSolid;
    gv.layers[3].RemoveStyleOverride;
    gv.layers[3].InitStyleOverride(so);
    assignfile(midfile,'closenodes.mid');
    reset(midfile);
    t:= cgfiso.objectcount;
    for i:= 1 to t do
    begin
      readln(midfile,line);
      if line[length(line)]='T' then so.brushcolor:= clRed else so.brushcolor:= clYellow;
      gv.Layers[3].OverrideStyle(i,so);
    end;
    closefile(midfile);

    gv.redrawimagedata;
  end;
  screen.cursor:= crDefault;
  showmessage('Nodes closer than 10 meter are marked on map');
end;

procedure TMainForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  tmp1,tmp2: TFloatRect;
  newcenter: TFloatPoint;
  deltaX,deltaY: double;
begin
  tmp1:= gv.display.actual;
  tmp2:= tmp1;

  mousepos.x:= mousepos.x-gv.left;
  mousepos.y:= mousepos.y-gv.top;
  newcenter:= gv.ScreenToCoOrd(mousePos);
  tmp1.left  := newcenter.x - (tmp2.right-tmp2.left)/2;
  tmp1.right := newcenter.x + (tmp2.right-tmp2.left)/2;
  tmp1.bottom:= newcenter.y - (tmp2.top-tmp2.bottom)/2;
  tmp1.top   := newcenter.y + (tmp2.top-tmp2.bottom)/2;

  tmp2:= tmp1;
  deltaX:= (tmp2.right-tmp2.left)*gv.ZoomFactor/200;
  deltaY:= (tmp2.top-tmp2.bottom)*gv.ZoomFactor/200;
  if wheeldelta>0 then
  begin
    tmp1.left:= tmp2.left+deltaX; tmp1.right:= tmp2.right-deltaX;
    tmp1.bottom:= tmp2.bottom+deltaY; tmp1.top:= tmp2.top-deltaY;
  end else
  begin
    tmp1.left:= tmp2.left-deltaX; tmp1.right:= tmp2.right+deltaX;
    tmp1.bottom:= tmp2.bottom-deltaY; tmp1.top:= tmp2.top+deltaY;
  end;
  gv.display.req:= tmp1;
  gv.RedrawImageData;
end;

procedure TMainForm.rwcalc1NWLoadProgress(Sender: TObject; Progress: Byte);
begin
  gauge1.progress:= progress;
end;

procedure TMainForm.rwcalc1NWCreateProgress(Sender: TObject; Progress: Byte;
  var StopProcess: Boolean);
begin
  gauge1.progress:= progress;
end;

procedure TMainForm.MultiIsochrones11Click(Sender: TObject);
var
  i,err: longint;
  t,tmax: double;
  so: TBasicObjectStyle;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  err:= rwcalc1.IsoCostMulti(nodenum,0);
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    if map.checked then
    begin
      clear;
      gv.layers[3].layerstate.visible:= false;
      so.PenWidth:= 2; so.PenColor:= clBlack; so.brushcolor:= clBlack;
      so.penmode:= pmCopy; so.PenStyle:= psSolid;
      if Sender=MultiIsochrones21 then
      begin
        for i:= 1 to rwnet1.linkmax do
        begin
          so.pencolor:= Fcolor[round(rwcalc1.ResultGetLink(i))];
          gv.Layers[2].OverrideStyle(i,so);
        end;
        for i:= 1 to rwnet1.nodemax do
        begin
          so.brushcolor:= Fcolor[round(rwcalc1.ResultGetNode(i))];
          gv.Layers[1].OverrideStyle(i,so);
        end;
      end else
      begin
        tmax:= 0;
        for i:= 1 to rwnet1.linkmax do
        begin
          t:= rwcalc1.getlinkcost(i);
          if (t>tmax) and (t<1e+36) then tmax:= t;
        end;
        for i:= 1 to rwnet1.linkmax do
        begin
          t:= rwcalc1.getlinkcost(i);
          if (t>=0) and (t<1e+36) then
          begin
            so.pencolor:= $00FFFF+$FFFF*round(t/tmax*255);
            gv.Layers[2].OverrideStyle(i,so);
          end;
        end;
        for i:= 1 to rwnet1.nodemax do
        begin
          t:= rwcalc1.getnodecost(i);
          if t<1e+36 then
          begin
            so.brushcolor:= $00FFFF+$FFFF*round(t/tmax*255);
            gv.Layers[1].OverrideStyle(i,so);
          end;
        end;
      end;
      gv.RedrawImageData;
    end else
    begin
      rwcalc1.resultfileclear(true,true);
      if Sender=MultiIsochrones11 then
      begin
        err:= rwcalc1.resultsaveLink;
        if err=0 then err:= rwcalc1.resultsaveNode;
      end else err:= rwcalc1.isocostsave(true,true,false);
      if err<0 then showmessage('Could not save result '+inttostr(err));
    end;
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.IsoGrid11Click(Sender: TObject);
var
  i,err,node: integer;
  so: TBasicObjectStyle;
  inp: textfile;
  line: string;
  mincost,maxcost,cost: double;
begin
  screen.cursor:= crHourglass;

  rwnet1.NodeIndexCreate;
  ShortestPathClick(ShortestPath);
  err:= rwcalc1.IsoGrid(nodenum,gv.Display.Actual.Left,gv.Display.Actual.Right,
                               gv.Display.Actual.Bottom,gv.Display.Actual.Top,
                               100,100,0.5);

  if err<>0 then
    showmessage('Error in function '+inttostr(err))
  else if not map.checked then
    showmessage('Import isogrid.mif to see the result in MapInfo/ArcView')
  else begin
    mifimport3.MIFLocation:= 'isogrid.mif';
    Mifimport3.Execute;
    cgfiso.active:= true;
    gv.layers[3].RemoveStyleOverride;

    so.PenWidth:= 0; so.PenColor:= clBlack; so.brushcolor:= clBlack;
    so.penmode:= pmCopy; so.PenStyle:= psClear;
    gv.layers[3].InitStyleOverride(so);

    if Sender=IsoGrid11 then
    begin
      assignfile(inp,'isogrid.mid');
      reset(inp);
      mincost:= 0; maxcost:= 0;
      for i:= 1 to cgfiso.ObjectCount do
      begin
        readln(inp,line);
        cost:= strtofloat(copy(line,1,pos(',',line)-1));
        if (i=1) or (cost<mincost) then mincost:= cost;
        if (i=1) or (cost>maxcost) then maxcost:= cost;
      end;
      closefile(inp);
      assignfile(inp,'isogrid.mid');
      reset(inp);
      for i:= 1 to cgfiso.ObjectCount do
      begin
        readln(inp,line);
        cost:= strtofloat(copy(line,1,pos(',',line)-1));
        so.brushcolor:= $00FFFF+$00FFFF*trunc((cost-mincost)/(maxcost-mincost)*255);
        gv.Layers[3].OverrideStyle(i,so);
      end;
      closefile(inp);
    end else
    begin
      assignfile(inp,'isogrid.mid');
      reset(inp);
      for i:= 1 to cgfiso.ObjectCount do
      begin
        readln(inp,line);
        node:= strtoint(copy(line,pos(',',line)+1,length(line)));
        so.brushcolor:= Fcolor[node];
        gv.Layers[3].OverrideStyle(i,so);
      end;
      closefile(inp);
    end;
    gv.layers[3].layerstate.visible:= true;
    gv.redrawimagedata;
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox.showmodal;
end;

procedure TMainForm.Create3centers1Click(Sender: TObject);
begin
  center(3);
end;

procedure TMainForm.Create8centers1Click(Sender: TObject);
begin
  center(8);
end;

procedure TMainForm.Create15centers1Click(Sender: TObject);
begin
  center(15);
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  showmessage('Menu items marked with M, relies on the random centers created here');
end;

procedure TMainForm.CheckBox3Click(Sender: TObject);
begin
  gv.layers[0].layerstate.visible:= checkbox3.checked;
  gv.RedrawImageData;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rwnet1.NWUnLoad;
end;

procedure TMainForm.gvMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  p: TPoint;
  fp: TFloatPoint;
  node,node2,length,i: integer;
  dist: single;
  so: Tbasicobjectstyle;
begin
  if (gv.mode=vpmUserDefined) and rwnet1.nwloaded then
  begin
    p.x:= x; p.y:= y;
    fp:= gv.ScreenToCoOrd(p);
    rwnet1.FindNodeFast(fp.x,fp.y,node,dist);
    if btnNearest.down then
    begin
      node2:= rwcalc1.NearestNode(node,nodenum);
      if node2>0 then
      begin
        length:= rwcalc1.RouteFind(rwcalc1.nodelistget(node2));
        so.PenWidth:= 2; so.PenColor:= clRed; so.brushcolor:= clRed;
        so.penmode:= pmCopy; so.PenStyle:= psSolid;
        for i:= 1 to length-1 do
          gv.Layers[2].OverrideStyle(abs(rwcalc1.routegetlink(i)),so);
        for i:= 2 to length-1 do
          gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(i),so);
        so.brushcolor:= clYellow;
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(1),so);
        gv.Layers[1].OverrideStyle(rwcalc1.routegetnode(length),so);
        gv.RedrawImageData;
      end else showmessage('No node found');
    end else
    if Node1Button.down then editnode1.text:= inttostr(node) else
    if Node2Button.down then editnode2.text:= inttostr(node);
  end;
end;

procedure TMainForm.mapClick(Sender: TObject);
begin
  gv.visible:= (Sender=map);
  toolbar972.visible:= (Sender=map);
  checkbox1.visible:= (Sender=map);
  checkbox3.visible:= (Sender=map);
  if Sender=tab then
  begin
    rwcalc1.ResultFileLink:= 'link.dat';
    rwcalc1.ResultFileNode:= 'node.dat';
  end;
  if Sender=shp then
  begin
    rwcalc1.ResultFileLink:= 'link.dbf';
    rwcalc1.ResultFileNode:= 'node.dbf';
  end;
end;

procedure TMainForm.IsoPoly2ButtonClick(Sender: TObject);
var
  i,err: integer;
  maxcost: double;
begin
//  center(3);
  screen.cursor:= crHourglass;

  try
    maxcost:= strtofloat(edit2.text);
  except
    on exception do
    begin
      maxcost:= 2; // zero isn't allowed
      edit2.text:= '2';
    end;
  end;

  rwcalc1.StepsClear;
  for i:= 1 to spinedit6.value do
    rwcalc1.StepsAdd(maxcost*i/spinedit6.value);
  err:= rwcalc1.isopoly2('isopoly2',nodenum);

  if err<>0 then
  begin
    screen.cursor:= crDefault;
    showmessage('Error in function '+inttostr(err))
  end else
  begin
    mifimport3.MIFLocation:= 'isopoly2.mif';
    Mifimport3.Execute;
    cgfiso.active:= true;
    gv.layers[3].RemoveStyleOverride;
    gv.layers[3].layerstate.visible:= true;
    gv.redrawimagedata;
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.IsoPoly3ButtonClick(Sender: TObject);
var
  err,i,node: integer;
  line: string;
  minx,maxy,miny,maxx,maxcost: double;
  inp: textfile;
  so: Tbasicobjectstyle;
begin
  screen.cursor:= crHourglass;

  maxcost:= 0;
  if checkbox5.checked then
  try
    maxcost:= strtofloat(edit1.text);
  except
  end;

  if checkbox4.checked and checkbox4.enabled then
  begin
    minx:= gv.display.Actual.Left;
    maxy:= gv.display.Actual.Top;
    miny:= maxy-gv.display.ActualHeight;
    maxx:= minx+gv.display.ActualWidth;
  end else
  begin
    minx:= 0;
    maxy:= 0;
    miny:= 0;
    maxx:= 0;
  end;

  err:= rwcalc1.isopoly3('isopoly3',maxcost,nodenum,spinedit5.value,minx,maxx,miny,maxy);

  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    mifimport3.MIFLocation:= 'isopoly3.mif';
    Mifimport3.Execute;
    cgfiso.active:= true;
    gv.layers[3].RemoveStyleOverride;
    gv.layers[3].layerstate.visible:= true;

    // if show nearest center, use different thematic mapping
    if checkbox6.checked then
    begin
      gv.layers[3].RemoveStyleOverride;

      so.PenWidth:= 0; so.PenColor:= clBlack; so.brushcolor:= clBlack;
      so.penmode:= pmCopy; so.PenStyle:= psClear;
      gv.layers[3].InitStyleOverride(so);

      assignfile(inp,'isopoly3.mid');
      reset(inp);
      for i:= 1 to cgfiso.ObjectCount do
      begin
        readln(inp,line);
        node:= strtoint(copy(line,pos(',',line)+1,length(line)));
        so.brushcolor:= Fcolor[node];
        gv.Layers[3].OverrideStyle(i,so);
      end;
      closefile(inp);
    end;
    gv.redrawimagedata;
    if not checkbox6.checked and notshowed then
    begin
      screen.cursor:= crDefault;
      showmessage('Here default colors are used. Can always be replaced by your own thematic mapping');
      notshowed:= false;
    end;
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',decimalseparator,#8]) then key:= #0;
end;

procedure TMainForm.editnode1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',#8]) then key:= #0;
end;

end.
