unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Menus, Gauges, Spin, ComCtrls, rwmain2;

type
  TMainForm = class(TForm)
    CreateButton: TButton;
    Memo1: TMemo;
    LoadButton: TButton;
    ClearButton: TButton;
    MainMenu1: TMainMenu;
    Advancedfunctions1: TMenuItem;
    Subnets1: TMenuItem;
    Parallellinks1: TMenuItem;
    CulDeSac1: TMenuItem;
    CulDeSac2: TMenuItem;
    Joinlinks1: TMenuItem;
    Distancetable1: TMenuItem;
    Standardfunctions1: TMenuItem;
    Drivedistance1: TMenuItem;
    TSP: TMenuItem;
    Gauge1: TGauge;
    Panel1: TPanel;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpinEdit3: TSpinEdit;
    CheckBox2: TCheckBox;
    IsoPoly1Button: TButton;
    SpinEdit4: TSpinEdit;
    Label4: TLabel;
    CloseNodes1: TMenuItem;
    MultiIsochrones11: TMenuItem;
    MultiIsochrones21: TMenuItem;
    Unusedlinks1: TMenuItem;
    Path1: TMenuItem;
    Shortestpath: TMenuItem;
    FastestPath: TMenuItem;
    About1: TMenuItem;
    Create3centers1: TMenuItem;
    Create8centers1: TMenuItem;
    Centers1: TMenuItem;
    Create15centers1: TMenuItem;
    N1: TMenuItem;
    Panel2: TPanel;
    Label5: TLabel;
    RandomButton: TButton;
    PathButton1: TButton;
    PathButton2: TButton;
    rwcalc1: TRWcalc;
    RWnet1: TRWnetBase;
    Panel3: TPanel;
    IsoPoly3Button: TButton;
    Viewresults1: TMenuItem;
    tab: TMenuItem;
    shp: TMenuItem;
    CheckBox5: TCheckBox;
    SpinEdit5: TSpinEdit;
    Label6: TLabel;
    CheckBox6: TCheckBox;
    Edit1: TEdit;
    editnode1: TEdit;
    editnode2: TEdit;
    Panel4: TPanel;
    IsoPoly2Button: TButton;
    Edit2: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    SpinEdit6: TSpinEdit;
    procedure CreateButtonClick(Sender: TObject);
    procedure PathButton1Click(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure RandomButtonClick(Sender: TObject);
    procedure Subnets1Click(Sender: TObject);
    procedure Distancetable1Click(Sender: TObject);
    procedure Drivedistance1Click(Sender: TObject);
    procedure TSPClick(Sender: TObject);
    procedure IsoPoly1ButtonClick(Sender: TObject);
    procedure CloseNodes1Click(Sender: TObject);
    procedure rwcalc1NWLoadProgress(Sender: TObject; Progress: Byte);
    procedure rwcalc1NWCreateProgress(Sender: TObject; Progress: Byte;
      var StopProcess: Boolean);
    procedure MultiIsochrones11Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure ShortestpathClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Create3centers1Click(Sender: TObject);
    procedure Create8centers1Click(Sender: TObject);
    procedure Create15centers1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mapClick(Sender: TObject);
    procedure IsoPoly3ButtonClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure editnode1KeyPress(Sender: TObject; var Key: Char);
    procedure IsoPoly2ButtonClick(Sender: TObject);
  private
    { Private declarations }
    procedure center(n: integer);
    procedure adjust;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  nodenum: integer;
  pathtype: byte;

implementation

uses math,about;

{$R *.DFM}

procedure TMainForm.center(n: integer);
var
  i,node: integer;
begin
  for i:= 1 to n do
  begin
    {random points, you should normally check that your points are on
     the main net and not in a subnet}
    node:= trunc(rwnet1.nodemax*random+1);
    rwcalc1.NodeListSet(i,node);
   end;
  nodenum:= n;
end;

procedure TMainForm.adjust;
begin
  case pathtype of
    0: begin
         rwcalc1.CostDist:= 1;
         rwcalc1.CostTime:= 0;
         rwcalc1.ExtraDist:= 0;
         rwcalc1.ExtraTime:= 1;
       end;
    1: begin
         rwcalc1.CostDist:= 0;
         rwcalc1.CostTime:= 1;
         rwcalc1.ExtraDist:= 1;
         rwcalc1.ExtraTime:= 0;
       end;
  end;
  rwcalc1.Alpha:= rwcalc1.OptimumAlpha;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  left:= 8;
  top:= 8;
  decimalseparator:= '.';
  pathtype:= 0;
  randseed:= 10;
  rwcalc1.SetNet(rwnet1); //link net-object and calc-object
end;

procedure TMainForm.ShortestpathClick(Sender: TObject);
begin
  TMenuitem(Sender).checked:= true;
  if sender=Shortestpath then pathtype:= 0;
  if sender=Fastestpath then pathtype:= 1;
  adjust;
end;

procedure TMainForm.CreateButtonClick(Sender: TObject);
var
  err: integer;
begin
  screen.cursor:= crHourglass;
  gauge1.Progress:= 0;
  gauge1.visible:= true;
  err:= rwnet1.NWCreateMIF('link',true);
  if err<>0 then showmessage('Could not create network: '+inttostr(err)) else
  begin
    err:= rwnet1.attributecreate('link.mid');
    if err<>0 then showmessage('Could not create attributes: '+inttostr(err));
  end;
  gauge1.visible:= false;
  screen.cursor:= crDefault;
end;

procedure TMainForm.LoadButtonClick(Sender: TObject);
var
  err: integer;
begin
  screen.cursor:= crHourglass;
  try
    gauge1.progress:= 0;
    gauge1.visible:= true;
    err:= rwnet1.NWLoad;
    gauge1.visible:= false;
    if err=0 then
    begin
      rwnet1.setspeed(1,110);
      rwnet1.setspeed(2,90);
      rwnet1.setspeed(3,80);
      rwnet1.setspeed(4,70);
      rwnet1.setspeed(5,60);
      rwnet1.setspeed(6,50);
      rwnet1.setspeed(17,110);
      rwnet1.setspeed(18,70);
      rwnet1.setspeed(19,50);
      rwnet1.setspeed(20,40);
      rwnet1.setspeed(21,35);
      rwnet1.setspeed(22,30);
      err:= rwnet1.attributeread(true);
      adjust;
      if err=0 then
      begin
        memo1.Lines.add('Number of links: '+inttostr(rwnet1.linkmax));
        memo1.Lines.add('Number of nodes: '+inttostr(rwnet1.nodemax));
        PathButton1.Enabled:= true;
        PathButton2.Enabled:= true;
        Advancedfunctions1.Enabled:= true;
        ClearButton.Enabled:= true;
        Standardfunctions1.Enabled:= true;
        Isopoly1button.Enabled:= true;
        Isopoly2button.Enabled:= true;
        Isopoly3button.Enabled:= true;
        RandomButton.enabled:= true;
        if rwcalc1.ExtraVarCreate<0 then showmessage('Extra variable has not been created');
        Centers1.enabled:= true;
        center(3);
      end else showmessage('Could not load attributes');
    end else showmessage('Could not load network');
  except
    on exception do showmessage('Try to create the network first');
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.PathButton1Click(Sender: TObject);
var
  node1,node2,i: longint;
  res: double;
  err: integer;
begin
  node1:= strtoint(trim(editnode1.text));
  node2:= strtoint(trim(editnode2.text));
  if (rwnet1.checknode(node1)) and (rwnet1.checknode(node2)) then
  begin
    if sender=PathButton2 then
    begin
      i:= node2; node2:= node1; node1:= i;
    end;
    res:= rwcalc1.route(node1,node2);
    if ((res>0) and (res<1e+36)) or (res=-33) then
    begin
      if res=-33 then rwcalc1.routefind(rwcalc1.bestnode)
        else rwcalc1.routefind(node2);
      err:= rwcalc1.routesave(true,true);
      if err<>0 then showmessage('Could not save result '+inttostr(err));
      if res=-33 then
        showmessage('Node '+inttostr(node2)+' was not found. Calculated route to nearest node instead')
      else
      case pathtype of
        0: memo1.lines.add(floattostrF(res,ffFixed,6,2)+' Km  '+floattostrF(rwcalc1.GetNodeExtra(node2),ffFixed,6,2)+' Min.');
        1: memo1.lines.add(floattostrF(rwcalc1.GetNodeExtra(node2),ffFixed,6,2)+' Km  '+floattostrF(res,ffFixed,6,2)+' Min.');
      end;
    end else showmessage('Could not find a route');
  end else showmessage('Wrong node-number(s)');
end;

procedure TMainForm.ClearButtonClick(Sender: TObject);
begin
  rwcalc1.resultfileclear(true,true);
end;

procedure TMainForm.RandomButtonClick(Sender: TObject);
begin
  editnode1.text:= inttostr(round(random(rwnet1.nodemax)+1));
  editnode2.text:= inttostr(round(random(rwnet1.nodemax)+1));
end;

procedure TMainForm.Subnets1Click(Sender: TObject);
var
  err: integer;
begin
  screen.cursor:= crHourglass;
  err:= 0;
  if Sender=Subnets1 then err:= rwcalc1.SubNet else
  if Sender=Parallellinks1 then err:= rwcalc1.ParallelLinks else
  if Sender=CulDeSac1 then err:= rwcalc1.CulDeSac(1) else
  if Sender=CulDeSac2 then err:= rwcalc1.CulDeSac(2) else
  if Sender=Unusedlinks1 then err:= rwcalc1.UnusedLinks else
  if Sender=Joinlinks1 then err:= rwcalc1.join(0,'');
  screen.cursor:= crDefault;
  if err<0 then showmessage('Error in function '+inttostr(err)) else
  begin
    if sender=CulDeSac2 then showmessage('All one-way streets are now two-way streets. Use load network to get back to normal');
    err:= rwcalc1.resultsavelink;
    if err<>0 then showmessage('Could not save link-result '+inttostr(err));
  end;
end;

procedure TMainForm.Distancetable1Click(Sender: TObject);
var
  output: textfile;
  i,j: longint;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  try try
    assignfile(output,'table1.txt');
    rewrite(output);
    write(output,'         ');
    for j:= 1 to nodenum do write(output,rwcalc1.nodelistget(j):8,' ');
    writeln(output);
    for i:= 1 to nodenum do
    begin
      rwcalc1.isocost(rwcalc1.nodelistget(i),0);
      write(output,rwcalc1.nodelistget(i):8,' ');
      for j:= 1 to nodenum do write(output,rwcalc1.getnodecost(rwcalc1.nodelistget(j)):8:2,' ');
      writeln(output);
    end;
    closefile(output);
    showmessage('Now look in "table1.txt" for the result');
  except
    on exception do showmessage('An error occured');
  end;
  finally
    screen.cursor:= crDefault;
  end;
end;

procedure TMainForm.Drivedistance1Click(Sender: TObject);
var
  node1: longint;
  err: integer;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  node1:= strtoint(trim(editnode1.text));
  err:= rwcalc1.isocost(node1,2);    // 2 km
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    err:= rwcalc1.isocostsave(true,true,false);
    if err<0 then showmessage('Could not save result '+inttostr(err));
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.TSPClick(Sender: TObject);
var
  j,node2,err: longint;
  res: double;
begin
  screen.cursor:= crHourglass;
  rwcalc1.tsp(nodenum,1);

  {draw results}
  for j:= 1 to nodenum do
  begin
    if j<>nodenum then node2:= rwcalc1.NodeListget(j+1) else node2:= rwcalc1.NodeListget(1);
    res:= rwcalc1.route(rwcalc1.NodeListget(j),node2);
    if (res>0) and (res<1e+36) then
    begin
      rwcalc1.routefind(node2);
      err:= rwcalc1.routesave(true,true);
      if err<>0 then showmessage('Could not save result '+inttostr(err));
    end else showmessage('Error when calculating route - node in subnet');
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.IsoPoly1ButtonClick(Sender: TObject);
var
  node,err: longint;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  node:= strtoint(trim(editnode1.text));
  err:= rwcalc1.isopoly1('isopoly1',node,spinedit1.value,spinedit2.value,
                       spinedit3.value,checkbox2.checked,spinedit4.value);
  screen.cursor:= crDefault;
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
    showmessage('You will have to import into mapinfo/arcview to see the result');
end;

procedure TMainForm.CloseNodes1Click(Sender: TObject);
var
  err: longint;
begin
  screen.cursor:= crHourglass;
  err:= rwnet1.findclosenodes(0.010);
  screen.cursor:= crDefault;
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
    showmessage('Import closenodes.mif to see the result in MapInfo/ArcView');
end;

procedure TMainForm.rwcalc1NWLoadProgress(Sender: TObject; Progress: Byte);
begin
  gauge1.progress:= progress;
end;

procedure TMainForm.rwcalc1NWCreateProgress(Sender: TObject; Progress: Byte;
  var StopProcess: Boolean);
begin
  gauge1.progress:= progress;
end;

procedure TMainForm.MultiIsochrones11Click(Sender: TObject);
var
  err: longint;
begin
  screen.cursor:= crHourglass;
  ShortestPathClick(ShortestPath);
  err:= rwcalc1.IsoCostMulti(nodenum,0);
  if err<>0 then showmessage('Error in function '+inttostr(err)) else
  begin
    rwcalc1.resultfileclear(true,true);
    if Sender=MultiIsochrones11 then
    begin
      err:= rwcalc1.resultsaveLink;
      if err=0 then err:= rwcalc1.resultsaveNode;
    end else err:= rwcalc1.isocostsave(true,true,false);
    if err<0 then showmessage('Could not save result '+inttostr(err));
  end;
  screen.cursor:= crDefault;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  AboutBox.showmodal;
end;

procedure TMainForm.Create3centers1Click(Sender: TObject);
begin
  center(3);
end;

procedure TMainForm.Create8centers1Click(Sender: TObject);
begin
  center(8);
end;

procedure TMainForm.Create15centers1Click(Sender: TObject);
begin
  center(15);
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  showmessage('Menu items marked with M, relies on the random centers created here');
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  rwnet1.NWUnLoad;
end;

procedure TMainForm.mapClick(Sender: TObject);
begin
  if Sender=tab then
  begin
    rwcalc1.ResultFileLink:= 'link.dat';
    rwcalc1.ResultFileNode:= 'node.dat';
  end;
  if Sender=shp then
  begin
    rwcalc1.ResultFileLink:= 'link.dbf';
    rwcalc1.ResultFileNode:= 'node.dbf';
  end;
end;

procedure TMainForm.IsoPoly2ButtonClick(Sender: TObject);
var
  i,err: integer;
  maxcost: double;
begin
  screen.cursor:= crHourglass;

  try
    maxcost:= strtofloat(edit2.text);
  except
    on exception do
    begin
      maxcost:= 2; // zero isn't allowed
      edit2.text:= '2';
    end;
  end;

  rwcalc1.StepsClear;
  for i:= 1 to spinedit6.value do
    rwcalc1.StepsAdd(maxcost*i/spinedit6.value);
  err:= rwcalc1.isopoly2('isopoly2',nodenum);
  screen.cursor:= crDefault;

  if err<>0 then showmessage('Error in function '+inttostr(err)) else
    showmessage('You will have to import into mapinfo/arcview to see the result');
end;

procedure TMainForm.IsoPoly3ButtonClick(Sender: TObject);
var
  err: integer;
  maxcost: double;
begin
  screen.cursor:= crHourglass;

  maxcost:= 0;
  if checkbox5.checked then
  try
    maxcost:= strtofloat(edit1.text);
  except
  end;

  err:= rwcalc1.isopoly3('isopoly3',maxcost,nodenum,spinedit5.value,0,0,0,0);
  screen.cursor:= crDefault;

  if err<>0 then showmessage('Error in function '+inttostr(err)) else
    showmessage('You will have to import into mapinfo/arcview to see the result');
end;

procedure TMainForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',decimalseparator,#8]) then key:= #0;
end;

procedure TMainForm.editnode1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in ['0'..'9',#8]) then key:= #0;
end;

end.
