unit Unit1;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, rwmain2;

type
  TForm1 = class(TForm)
    Button1: TButton;
    RWcalc1: TRWcalc;
    RWnetBase1: TRWnetBase;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  node1,node2,errorV: integer;
  dist: single;
begin
  errorV:= rwnetbase1.NWcreateMIF('link',false);
  if errorV=0 then
  begin
    errorV:= rwnetbase1.NWload;
    if errorV=0 then
    begin
      randomize;
      repeat
        node1:= round(rwnetbase1.nodemax*random+1);
        node2:= round(rwnetbase1.nodemax*random+1);
        dist:= rwcalc1.Route(node1,node2);
        if dist<0 then showmessage('Error code: '+floattostrF(dist,ffFixed,3,0)) else
          showmessage('From node '+inttostr(node1)+' to node '+inttostr(node2)+': '+floattostrF(dist,ffFixed,5,2)+' Km');
      until MessageDlg('Do you want to continue?',mtConfirmation, [mbYes, mbNo], 0) = mrNo;
      rwnetbase1.NWunload;
    end else
      showmessage('Network could not be loaded: Errorcode = '+inttostr(errorV));
  end else
    showmessage('Network could not be created: Errorcode = '+inttostr(errorV));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  rwcalc1.SetNet(rwnetbase1);
end;

end.
